//-----------------------------------------------
//---------------Panorama horizontal-----------
//-----------------------------------------------

void PanoLoop() {

  unsigned long currentMillis = millis();

  
  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);


 

  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();



if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {
    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt


      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;
          
          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
       
		Serial1.print(StringSend);

          SMSdauer = TLmaxexpo;
          break;

        case 3: // Move



          if (((int)currentRow % 2) == 1) {
            if (currentColumn == panoColumns) {
              currentColumn = panoColumns;
              currentRow = currentRow + 1;
              //   Serial.println("---1");
            }
            else {
              currentColumn = currentColumn + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentColumn == 1) {
              currentColumn = 1;
              currentRow = currentRow + 1;

              // Serial.println("---3");
            }
            else {
              currentColumn = currentColumn - 1;
              // Serial.println("---4");
            }
          }



          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);



          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);

          // Serial.println(String(currentColumn));
          // Serial.println(String(tempGerundetX));
          // Serial.println(String(currentRow));
          // Serial.println(String(tempGerundetY));
          // Serial.println("---");

          myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial1.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial1.print(StringSend);

          SMSdauer = 500;
          break;

        case 4: // Delay
		
		
        SMSdauer = TLdelay + 500;
          if (TLdelay > 1000) {
            SMSdauer = 1500;
          }



          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

 if (pausePano == false) {
        // Serial.println("444");
        previousMillis = currentMillis; // "Delay" neu starten
      }

    }  //  if (currentMillis  - previousMillis > Dauer )
  }

  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
    SMSstep = 0;
    previousMillis = 0;
    tempGerundetX = 0;
    tempGerundetY = 0;
    startPano = false;
  }

}

//-----------------------------------------------
//---------------Panorama vertical-----------
//-----------------------------------------------

void PanoLoopVertical() {
  unsigned long currentMillis = millis();






  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);


   AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();


  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {



    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt


      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;
          //  Serial.print("panoCurrentPic:");
          // Serial.println(panoCurrentPic);

          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          Serial1.print(StringSend);
          SMSdauer = TLmaxexpo;
         // Serial.print("TLmaxexpo:");
          //Serial.print(TLmaxexpo);

          break;

        case 3: // Move



          if (((int)currentColumn % 2) == 1) {
            if (currentRow == panoRows) {
              currentRow = panoRows;
              currentColumn = currentColumn + 1;
              //   Serial.println("---1");
            }
            else {
              currentRow = currentRow + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentRow == 1) {
              currentRow = 1;
              currentColumn = currentColumn + 1;

              // Serial.println("---3");
            }
            else {
              currentRow = currentRow - 1;
              // Serial.println("---4");
            }
          }

 myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial1.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial1.print(StringSend);

          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);

          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);

     
     


          SMSdauer = 500;
          break;

        case 4: // Delay
         // Serial.print("TLdelay:");
         // Serial.println(TLdelay);
          SMSdauer = TLdelay + 500;

          if (TLdelay > 1000) {
            SMSdauer = 1500;
          }


          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if (pausePano == false) {

        previousMillis = currentMillis; // "Delay" neu starten
      }


    }  //  if (currentMillis  - previousMillis > Dauer )
  }




  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
 SMSstep = 0;
    previousMillis = 0;
    tempGerundetX = 0;
    tempGerundetY = 0;
     startPanoVertical = false;
  }

}










